<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_instrumentation_log".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnInstrumentationLog".
 *
 * Columns in table "cpn_instrumentation_log" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property string $application_name
 * @property string $session_identifier
 * @property string $event_type
 * @property string $event_category
 * @property string $event_timestamp
 * @property string $ui_element_type
 * @property string $ui_event_type
 * @property string $ui_target_object
 * @property string $ui_event_result
 * @property string $app_identifier
 * @property string $app_version
 * @property string $app_installation_identifier
 * @property string $app_secret
 * @property string $app_method
 * @property string $source_message
 * @property string $date_added
 *
 */
abstract class BaseCpnInstrumentationLog extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_instrumentation_log';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnInstrumentationLog|CpnInstrumentationLogs', $n);
    }

    public static function representingColumn()
    {
        return 'application_name';
    }

    public function rules()
    {
        return array(
            array('application_name, session_identifier, event_type, event_category, event_timestamp, '
                . 'ui_element_type, ui_event_type, ui_target_object, ui_event_result, app_identifier, '
                . 'app_version, app_installation_identifier, app_secret, app_method, source_message', 'required'),
            array('application_name, session_identifier, event_type, event_category, app_identifier, '
                . 'app_installation_identifier, app_method', 'length', 'max' => 255),
            array('ui_element_type, ui_event_type, ui_target_object, ui_event_result, app_version, '
                . 'app_secret', 'length', 'max' => 45),
            array('date_added', 'safe'),
            array('date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, application_name, session_identifier, event_type, event_category, event_timestamp, '
                . 'ui_element_type, ui_event_type, ui_target_object, ui_event_result, app_identifier, '
                . 'app_version, app_installation_identifier, app_secret, app_method, source_message, '
                . 'date_added', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'application_name' => Yii::t('app', 'Application Name'),
            'session_identifier' => Yii::t('app', 'Session Identifier'),
            'event_type' => Yii::t('app', 'Event Type'),
            'event_category' => Yii::t('app', 'Event Category'),
            'event_timestamp' => Yii::t('app', 'Event Timestamp'),
            'ui_element_type' => Yii::t('app', 'Ui Element Type'),
            'ui_event_type' => Yii::t('app', 'Ui Event Type'),
            'ui_target_object' => Yii::t('app', 'Ui Target Object'),
            'ui_event_result' => Yii::t('app', 'Ui Event Result'),
            'app_identifier' => Yii::t('app', 'App Identifier'),
            'app_version' => Yii::t('app', 'App Version'),
            'app_installation_identifier' => Yii::t('app', 'App Installation Identifier'),
            'app_secret' => Yii::t('app', 'App Secret'),
            'app_method' => Yii::t('app', 'App Method'),
            'source_message' => Yii::t('app', 'Source Message'),
            'date_added' => Yii::t('app', 'Date Added'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('application_name', $this->application_name, true);
        $criteria->compare('session_identifier', $this->session_identifier, true);
        $criteria->compare('event_type', $this->event_type, true);
        $criteria->compare('event_category', $this->event_category, true);
        $criteria->compare('event_timestamp', $this->event_timestamp, true);
        $criteria->compare('ui_element_type', $this->ui_element_type, true);
        $criteria->compare('ui_event_type', $this->ui_event_type, true);
        $criteria->compare('ui_target_object', $this->ui_target_object, true);
        $criteria->compare('ui_event_result', $this->ui_event_result, true);
        $criteria->compare('app_identifier', $this->app_identifier, true);
        $criteria->compare('app_version', $this->app_version, true);
        $criteria->compare('app_installation_identifier', $this->app_installation_identifier, true);
        $criteria->compare('app_secret', $this->app_secret, true);
        $criteria->compare('app_method', $this->app_method, true);
        $criteria->compare('source_message', $this->source_message, true);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
